
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>阿里云上的容器技术实践详解 / iVAN</title>

    <meta name="description" content="阿里云上的容器技术实践详解 为什么选择阿里云 本文讲的是阿里云上的容器技术实践详解,现在的公有云如雨后春笋,国外如AWS.Azure.Bluemix,国内如BAT.DaoCloud.goodrain,都可以给大家提供丰富的云基础设施和上层服务,那么,为什么选择阿里云呢?主要有三点想法: 我们使用阿里云的服务已经有5年了,从企业级PaaS平台合作开始,再到帮助我们的一些客户逐步迁云,对阿里云的能力还是比较熟悉的. 因为要做的是容器,国外AWS,Azure虽然有,但AWS在中国一直没&quot;正规&quot;数据中心(唯一的 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">阿里云上的容器技术实践详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>为什么选择阿里云</p>
<p>本文讲的是<strong>阿里云上的容器技术实践详解，</strong>现在的公有云如雨后春笋，国外如AWS、Azure、Bluemix，国内如BAT、DaoCloud、goodrain，都可以给大家提供丰富的云基础设施和上层服务，那么，为什么选择阿里云呢？主要有三点想法：</p>
<p>我们使用阿里云的服务已经有5年了，从企业级PaaS平台合作开始，再到帮助我们的一些客户逐步迁云，对阿里云的能力还是比较熟悉的。</p>
<p>因为要做的是容器，国外AWS，Azure虽然有，但AWS在中国一直没“正规”数据中心（唯一的一个前几天还被查了），Azure是微软体系（也许是心里作祟，总感觉不对口...）；而国内虽然一些公有云有容器能力，但规模普遍偏小；再者，阿里云反正也开始做容器了，说明人家底层还是有支持能力的。</p>
<p>当然，还有一个做法，自建数据中心或租赁IDC，不过做事情还是的慢慢来，不到一定规模，前期投入还是比较大的。</p>
<p>怎么用阿里云</p>
<p>有人问，在IT领域，现在跟10年前比，对技术人员或架构师要求有什么不同？</p>
<p>我是这么来看的：以前大多数是做加法 —— 每个领域就那几个产品或框架，需要的更多是集成能力；现在是要做减法，因为技术栈太多了（全栈工程师不好当呀...），到底选哪些，这往往是最考验能力的。</p>
<p>我们最终选择了Kubernetes+CoreOS+docker的组合，当然少不了辅助的Etcd、Flannel...……大家可能会问：为什么不用ubuntu、ranchar啊，为什么不用OVS啊，其实我们都是有理由的，这篇文章里不是重点，之后再交流。</p>
<p>那紧接着要做什么也就明了了，在阿里云的ECS上先跑CoreOS（docker反正自带了），然后去部署Kubernetes那一整套，验证验证技术可行性吧。可以的话，再做分布式存储，然后支持DevOps，自动化运维，先后顺序也很好选。</p>
<p>没有问题是不可能的</p>
<p>大家可以到阿里云官网上去搜下docker，或者kvm类似的，映入眼帘的是以下这张图：</p>
<p>千万别气馁，因为都有CoreOS镜像了，不支持docker谁信（其实阿里云还是蛮务实的，没有经过严格测试不敢说支持），好歹也得试一试，于是就先买了几台CoreOS机器，接下来做的一些事情就不那么顺利了：</p>
<p>先做系统升级（默认版本比较低了，681.2.0 64位），那大家都知道外网流量很贵，所以最好搭个内部升级服务器，在升级后发现网络有问题，进不去，内部进入发现原因是网络没起来，这工作只有先手工做了（systemctlrestart systemd-networkd.service）。</p>
<p>升级完了，最好的习惯是去打快照（当然，这个服务过些天就要收钱了，还挺贵的...），发现没打出来，这个问题排了好久，最后的原因是自作孽啊，删了个自认为没用的yunservice，后来想想也觉得自己幼稚了，都叫"yun"了，肯定是阿里云留下做事情的呀。</p>
<p>kubernetes安装，一般来说有三种安装方式，命令型、服务型、容器型，技术成本考虑，最终我们先用了前两种的混合态，然后setup-network-enviroment辅助验证，还好没遇到大问题，容器间网络很快通了（我们用了container模式，端口映射出去）。</p>
<p>因为在VPC环境，我们使用了EIP，但IP资源实在是宝贵（20个），所以留了一个做堡垒机，其他的大部分给了计算节点，由kubernetes的service public IP消费了，这点告诉我们，宝贵资源大家前期一定要做好规划。</p>
<p>内部DNS能力，用了skyDNS，一个比较坑的问题：一定要用最新版本，之前哪怕是release版本都有问题，服务注册后进不去出不来的，反正挺诡异的，一直也没见说哪个版本修复的。</p>
<p>跑服务过程中遇到了棘手问题，大家都知道kubernetes的容器调度能力，会结合自身的一些分析，在运行时把pod做热迁，放到他认为合适的机器上，这就使得容器用宿主机本地磁盘不现实了，持久化数据没法迁移或共享呀（当然，有同学说可以通过label强制运行在某处，但好特性还是想用一用，不然什么都规划好，这和云的宗旨就貌合神离了），这怎么办？分布式存储是个好方案，但阿里的块存储服务还没发布，虽然我们一直是决定自己搭，但那也是下个版本的事情了，这边先low了一下，只能先用NFS临时解决。</p>
<p>最终架构和技术栈</p>
<p>上面罗里吧嗦地说了过程中遇到的一些问题，当然还有，就不详举了，不然就变成了公有云吐槽了！</p>
<p>这里想简单再分享下我们的技术栈和架构，希望对大家有用。</p>
<p>刚才已经把容器技术栈给说了，接着就是容器里跑的微服务使用技术了：</p>
<p>springboot，让微服务编码、配置、部署、监控变得更简单</p>
<p>react+redux，让前端也可以微服务化</p>
<p>MetaCube（自研产品），元数据，提供资源全图、驱动运营</p>
<p>Redmine，提供产品和服务管理</p>
<p>ElasticSearch、InfluxDB，运维监控能力</p>
<p>BPS（自研产品），一体化的流程能力</p>
<p>其他还有好多，saltstack、gitlab、Jenkins、autoconfig、OAuth等等，不细说了。</p>
<p>平台是以DevOps为核心的，最终架构如下：</p>
<p><a href="https://yqfile.alicdn.com/198bd681ece55df6117c12afecb1e1ec934c443a.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzE5OGJkNjgxZWNlNTVkZjYxMTdjMTJhZmVjYjFlMWVjOTM0YzQ0M2EucG5n.jpg"></a></p>
<p>围绕统一接入，自动化协作，运营反馈等，建设了完整的企业级云平台，后面我会分模块一一介绍，大家先概览一下就可以了。</p>
<p>还有一些其他的能力建设</p>
<p>包括高可靠、高性能、灰度发布、熔断、APIGateway、自动化、安全控制…，大家有兴趣可以一起交流，共同进步。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 06:56:08</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9e%b6%e6%9e%84/" title="架构">架构</a>, <a href="https://www.iamivan.net/tag/%e9%98%bf%e9%87%8c%e4%ba%91/" title="阿里云">阿里云</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e4%b8%ad%e5%bf%83/" title="数据中心">数据中心</a>, <a href="https://www.iamivan.net/tag/%e5%ae%b9%e5%99%a8/" title="容器">容器</a>, <a href="https://www.iamivan.net/tag/docker/" title="docker">docker</a>, <a href="https://www.iamivan.net/tag/%e5%85%ac%e6%9c%89%e4%ba%91/" title="公有云">公有云</a>, <a href="https://www.iamivan.net/tag/%e5%be%ae%e6%9c%8d%e5%8a%a1/" title="微服务">微服务</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f%e5%ad%98%e5%82%a8/" title="分布式存储">分布式存储</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>阿里云上的容器技术实践详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5ZZwWz.html" rel="bookmark">【阿里云资讯】Docker首个国内合作商，阿里云何以认定容器技术将成主流？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阿里成Docker首个国内合作商 10月13日,在2016杭州·云栖大会上,全球知名的容器技术公司Docker与阿里云宣布达成战略合作,双方将在容器服务领域进行紧密合作,阿里云称其将为客户提供更加先进的云上应用管理服务.双方称在开源容器技术以及其发展方向共同努力,为客户提供本地化Docker的企业级支持和咨询服务. Docker自问世三年来,社区不断壮大,项目升温之迅猛在开源社区中并不多见,并受到IT业内的广泛关注.不过,Docker在国内真正的大规模应用仍然不多,目前国内Docker的使用状况			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQlaqp.html" rel="bookmark">女娲：阿里云分布式一致性协同服务架构详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				他的演讲内容主要分为四个方面:分布式协同服务背景.女娲服务架构以及技术演进.典型女娲服务应用场景分享.全球化架构下的女娲进化,下面是本次分享内容整理.点击查看回顾视频 分布式协同服务背景 分布式协同服务 在大规模云计算场景中,为保障数据分布式一致性,数量众多的计算节点往往依赖分布式协同服务来同步对共享资源的互斥访问,或者依赖分布式协同服务的消息通知功能来协调各自之间动作,使众多节点作为一个整体完成一项工作. 作为云计算分布式系统的核心,在设计分布式协同服务之初需要考虑互斥性.消息通知和扩展性三个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR8018z.html" rel="bookmark">阿里云直播PHP SDK使用方法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.直播云没有单独的SDK,直播部分的SDK是直接封装在CDN的相关的SDK里面 2.针对SDK,没有demo. 3.针对SDK,没有相关的文档说明. 4.针对SDK的说明,网站上面的说明与源码里面的说明完全不一致. 5.针对SDK没有封装那些常用的访问,需要用户组合调用SDK进行拼装,总之一句,这也太抽象,看看人家七牛的API,哎,不多说啥了 6.提供的SDK路径乱的一踏糊涂,想直接用没门,得各种调整. 7.针对SDK基于PHP更高登记的版本,照顾不到一些低版本用户. 针对上面几点原因,踩了一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5249Rz.html" rel="bookmark">【X-Pack解读】阿里云Elasticsearch X-Pack 安全组件功能详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				X-Pack Security 2017年1月爆发了Elasticsearch数据勒索事件,涉及到的数据至少500亿条,被删除数据至少450TB.如何提高Elasticsearch应用的安全性,是开发者面临的重要问题.Elasticsearch X-Pack中的安全组件提供了对应的安全解决方案,让IT和应用团队能够依赖 X-Pack 来区分和管理正常用户和恶意入侵者:与此同时,Elasticsearc中存储的数据始终享有可靠的安全保障,公司高管和客户都能高枕无忧. 密码管理 要想保护流经 Ela			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9XaQvb.html" rel="bookmark">【X-Pack解读】阿里云Elasticsearch X-Pack 监控组件功能详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				X-Pack Monitoring 阿里云Elaticsearch已集成X-Pack组件,用户可以开箱即用监控功能,依靠运行Agent收集和监控Elaticsearch.Logstach.Kibana等实例的索引和指标,并借助Kibana可视化能力实时监控这些应用. ELK应用性能监控 X-Pack monitoring 功能提供了一种有效方法,让您能够密切关注 Elasticsearch.Kibana 和 Logstash 的性能.它的仪表板集合能够帮助您在各个层级上评估仪表板的状态,同时为您			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGny36p.html" rel="bookmark">【X-Pack解读】阿里云Elasticsearch X-Pack 机器学习组件功能详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				X-Pack Machine Learning 数据复杂多变,当出现基础设施问题.入侵者或业务问题时,几乎不可能利用规则或通过人工监视仪表板发现问题.阿里云Elaticsearch的X-Pack引入了机器学习功能machine learning,可以实时地自动模拟 Elasticsearch 数据的行为--趋势.周期等.从而更快地发现问题.简化问题根源分析.降低误报率. 透过数据表象 借助机器学习功能,Elasticsearch能够机敏地迅速回答 &quot;上周各小时每秒请求数量是多少?&quot; 等			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0WG4Pb.html" rel="bookmark">性能与性价比的平衡，阿里云第二代入门级实例T5详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在2017杭州云栖大会上,阿里云副总裁李津发布了ECS全新一代入门级实例T5,其中最大的亮点是:T5与ECS刚刚发布的企业级实例采用同一基础设施平台,让T5在提供高性价比的同时,也能拥有企业级ECS的稳定基因. 该系列实例主要面对的场景是:平时 CPU低利用率较低,但间歇性又需要瞬时对 CPU 占用较高的场景:比如一些轻量级网站.Web应用服务.测试.开发或其他低负载应用.但同时又需要在us甚至ms时间内能够快速响应瞬间高 CPU 资源使用需求,ECS T5 实例正是为这种场景而生. 较以往面向			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvv8j9M.html" rel="bookmark">【X-Pack解读】阿里云Elasticsearch X-Pack 告警组件功能详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				X-Pack Alerting CPU 使用率意外增加, 应用响应时间激增:503 错误的数量火箭式上升:Elasticsearch 索引率直线下降.尽管情况层出不穷,但是您可以通过X-Pack的告警组件Alerting发送您所需的警报,让您随时随刻掌握应用情况. 检测数据变化 X-Pack 中的 alerting 功能可让您充分利用 Elasticsearch 查询语言,当数据发生令您感兴趣的变化后,您能够发现这些变化. 换言之,如果您能够在 Elasticsearch 中查询某些数据,就能够			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6wOyYp.html" rel="bookmark">【X-Pack解读】阿里云Elasticsearch X-Pack 报告组件功能详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				X-Pack Reporting 阿里云Elaticsearch用户可以开箱即用X-Pack的报告组件功能,能够为Kibana 可视化或仪表板快速生成报告.用户可以即需即取报告.预约报告.根据特定条件触发报告,并自动将报告分享给他人如经理.客户.合规专员.报告所采用的架构为报告赋予了可扩展性,并且便于报告传输,让您能够随时随地获取 Kibana 中的信息. 自定义报表导出 Kibana 是您可视化和探索 Elasticsearch 数据的绝佳方法.X-Pack reporting 功能让您能够轻			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpm7O5b.html" rel="bookmark" class="title">电脑运行速度慢该怎么办？</a>
					<div>
						  所有电脑在使用一段时间之后都会有所变化,有的可能是运行起来越来越卡,有的可能是开机比较慢,无论你的电脑发生了什么情况,都预示着你该好好调整一下你的电脑了.电脑运行的快慢和硬盘有着直接的关系,我们无 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlg3qb.html" rel="bookmark" class="title">初学网页应知：用实例来学习HTML</a>
					<div>
						初学|网页 记得在本人刚开始学习编写网页时曾向一位WEB高手请教过如何用FRONTPAGE 98来制作一张绚丽多姿的个人网页.他告诉我,他制作网页时不用任何网页制作软件,而是靠手写的.当时我一下子愣住 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbaDBXz.html" rel="bookmark" class="title">列表元素空隙问题的解决方法</a>
					<div>
						解决|问题  今天看了一个网页中有一个列表在IE中与在FF中的表现不太正确,哪一个是正确的,不是太清楚,后来才明白是IE的问题,FF表现是正确的.我写了一个简略版本的如下:&lt;!DOCTYPE h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGDelb.html" rel="bookmark" class="title">MySQL实现表中取出随机数据</a>
					<div>
						mysql|数据|随机 以前在群里讨论过这个问题,比较的有意思.mysql的语法真好玩.他们原来都想用PHP的实现随机,但取出多条好像要进行两次以上查询.翻了手册,找到了下面这个语句,可以完成任务了. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPd4GM.html" rel="bookmark" class="title">Kruskal算法&lpar;二&rpar; C&plus;&plus;详解</a>
					<div>
						最小生成树 在含有n个顶点的连通图中选择n-1条边,构成一棵极小连通子图,并使该连通子图中n-1条边上权值之和达到最小,则称其为连通网的最小生成树. 例如,对于如上图G4所示的连通网可以有多棵权值总和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBqRWb.html" rel="bookmark" class="title">Windows 8&period;1下新版邮件应用详解</a>
					<div>
						来自Winsupersite博客的Paul Thurrott向我们展示了最新泄露版本号为9471的Windows 8.1内部的有趣细节改动,今天Thurrott再次贴出多张图片展示即将到来新系统内的邮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1wamz.html" rel="bookmark" class="title">java中通过xpath处理含有命名空间</a>
					<div>
						声明:以下的测试是用的jdk1.4.2,xalan7.0对于如下xml文档片断: &lt;ML:MREML xmlns:ML=&quot;MREML&quot;&gt;&lt;EnvelopEntit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91Q2RM.html" rel="bookmark" class="title">Samba资源共享配置详解</a>
					<div>
						Samba大致工作过程如下: 实例分析:安装使用3.5版本的samba实现windows与linux资源共享的功能 1. 先卸载系统自身携带的3.0的samba版本 [root@station45 ~ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7oWVb.html" rel="bookmark" class="title">诊断Java代码&colon; 提高Java代码的性能</a>
					<div>
						很多算法用尾递归方法表示会显得格外简明.编译器会自动把这种方法转换成循环,以提高程序的性能.但在 Java 语言规范中,并没有要求一定要作这种转换,因此,并不是所有的 Java 虚拟机(JVM)都会做 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwqRQz.html" rel="bookmark" class="title">PS教你绘制中国风的武侠秘籍封面</a>
					<div>
						  最终效果: 参考图素: 绘制步骤 首先绘制书的轮廓,建立书的基本样式.(色值314f7c) 添加投影.内阴影.渐变叠加效果营造立体感.添加书签样式,叠加纹理,制作纸质破损感觉. 添加布质纹理效果. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKL1Vp.html" rel="bookmark" class="title">用Ruby进行CGI编程的入门指引</a>
					<div>
						  这篇文章主要介绍了用Ruby进行CGI编程的入门指引,编写CGI脚本也是Ruby用于网络编程的一项基础功能,需要的朋友可以参考下 编写CGI脚本: 最基本的Ruby CGI脚本看起来像这样: ?  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBmQaz.html" rel="bookmark" class="title">如何避免cpu过热，cpu温度高怎么办</a>
					<div>
						中央处理器(英文Central ProcessingUnit,CPU)是一台计算机的运算核心和控制核心.CPU. 内部存储器和输入/输出设备是电子计算机三大核心部件.其功能主要是解释计算机指令以及处理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBP1Nz.html" rel="bookmark" class="title">如何解决电脑桌面卡死的问题</a>
					<div>
						  一.按下组合键 &quot;ctrl + alt + esc &quot;打开任务管理器,然后选择进程选项卡.在进程中找到 explorer.exe 进程,然后按&quot;结束进程&quot;按 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvG88Vp.html" rel="bookmark" class="title">java中System&period;out&period;println&lpar; &rpar;&semi;这个方法是</a>
					<div>
						问题描述 java中System.out.println( );这个方法是 java中System.out.println( );这个方法是System类里的out对象的println方法的意思,即类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPN7rp.html" rel="bookmark" class="title">as 3&period;0做放大镜效果代码</a>
					<div>
						参数变量:mc:需要放大的图形*/ as 3.0做放大镜效果代码 package maths{         import flash.display.Bitmap;         import  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEmPqp.html" rel="bookmark" class="title">设计-类似最小生成树的算法求解答</a>
					<div>
						问题描述 类似最小生成树的算法求解答 输入一些二元组,二元组代表连通的两个节点.所有的二元组构成一个无向图.现在请你设计一个算法,求出一个最小生成树,使得图中没有回路,并且连接所有节点.输出的数据也用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b326Zgz.html" rel="bookmark" class="title">c语言-结构体内指针字符数组的释放</a>
					<div>
						问题描述 结构体内指针字符数组的释放 问题:结构体成员char* name和结构体struct student* studentIOS同时释放的话回报错,错误见代码中注释.请问这里要怎么释放呢?还是结 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQ9POp.html" rel="bookmark" class="title">c&plus;&plus;-列表初始化是通过 initializer&lowbar;list 实现的吗？</a>
					<div>
						问题描述 列表初始化是通过 initializer_list 实现的吗? &lt;C++ Primer&gt;第五版,中文版.p39. 请输入长度为30-10000的问题描述 解决方案 具体参考:ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRDq1b.html" rel="bookmark" class="title">sadasdasdsd-SSH中Hibernate具体在项目中怎么用的</a>
					<div>
						问题描述 SSH中Hibernate具体在项目中怎么用的 SSH中Hibernate具体在项目中怎么用的 SSH中Hibernate具体在项目中怎么用的 SSH中Hibernate具体在项目中怎么用的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12Nr9p.html" rel="bookmark" class="title">PostgreSQL 利用编译器extension 支持int128，提升聚合性能</a>
					<div>
						标签 PostgreSQL , int128 , clang , gcc , icc 背景 PostgreSQL 9.4以及以前的版本,在INT,INT2,INT8的聚合计算中,为了保证数据不会溢出, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12D85p.html" rel="bookmark" class="title">新的便利云产品</a>
					<div>
						日前,很小的一部分云计算厂商能够提供一个灵活的.可扩展的.已可供企业实际应用的完整云计算产品或者说是服务.Citrix公司关于云计算的新产品,允许企业用户创建一个新的基础设施用于云计算,并可以转给他人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdygD4z.html" rel="bookmark" class="title">杨骅：迎来TD放量</a>
					<div>
						孙琎 担任TD-SCDMA产业联盟秘书长快7年的杨骅,是TD成长的见证人和培育人,他的职业生涯已经与TD密不可分,以至于有人戏称,他的头发都为发展TD产业联盟累光了. 2002年10月,在人民大会堂, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3J427z.html" rel="bookmark" class="title">数字化时代，物流与零售业的正确打开方式</a>
					<div>
						本文讲的是 :  数字化时代,物流与零售业的正确打开方式  ,[IT168 评论]&quot;如果你的居住地突然入驻了亚马逊,那么这里会发生什么样的化学变化呢?&quot; ▲Infor亚太及日本地区 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwxgZM.html" rel="bookmark" class="title">resteasy经验谈</a>
					<div>
						resteasy 是java体系中比较成熟的rest框架,也是jax-rs规范的实现之一,dubbox的REST服务框架,就是采用的resteasy实现,近日在实际项目中遇到了几个问题,记录于此:   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYlnZb.html" rel="bookmark" class="title">我们对互联网的崇拜，是不是有点过火</a>
					<div>
						华为总裁任正非在近日关于重装旅组织汇报会议上指出,华为不要去炒作互联网精神,应踏踏实实的去夯实基础平台,让端到端的实施过程透明化. 以下为讲话实录: 一.重装旅的目的是加强干部和专家循环,盘活人力资源 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWq6kz.html" rel="bookmark" class="title">java按指定编码写入和读取文件内容的类分享&lowbar;java</a>
					<div>
						可以指定编码如:utf-8来写入和读取文件.如果文件编码未知,可以通过该方法先得到文件的编码后再指定正确的编码来读取,否则会出现文件乱码问题. 如何识别文件编码请参考:java自动根据文件内容的编码来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvqKNM.html" rel="bookmark" class="title">videocapture库制作python视频高速传输程序&lowbar;python</a>
					<div>
						1,首先是视频数据[摄像头图像]的采集,通常可以使用vfw在vc或者vb下实现,这个库我用的不好,所以一直不怎么会用.现在我们用到的是python的videocapture库,这个库用起来很简单,如下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBk4lJM.html" rel="bookmark" class="title">Android Fragment使用之实例演示&lowbar;Android</a>
					<div>
						          Fragment是Android honeycomb 3.0新增的概念,在如何使用Android Fragment中做了关于Fragment的详细介绍.本文则主要是通过实例的方式让 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYjPPb.html" rel="bookmark" class="title">利用ASP&period;NET设计FTP文件上传（</a>
					<div>
						&lt;% @ Import Namespace=&quot; System.IO &quot; %&gt;&lt;html &gt;&lt;BODY &gt;&lt;SCRIPT LANGUAGE  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0N0KDz.html" rel="bookmark" class="title">mybatis-使用MyBatis框架向MySQL数据库增加数据使用浏览器访问出现错误</a>
					<div>
						问题描述 使用MyBatis框架向MySQL数据库增加数据使用浏览器访问出现错误 org.apache.ibatis.binding.BindingException: Parameter 'name ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
